#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/mman.h> 
#include <unistd.h>

int main(int argc, char *argv[]) {
	// dimensione delle pagine
    int pagesize = getpagesize();

    printf("page_size=%d\n", pagesize);
	
	// mappa nuova memoria
	char *p = mmap(
		NULL,                    // il kernel sceglie a quale indirizzo mappare la memoria
		pagesize,                // mappa una singola pagina            
		PROT_READ | PROT_WRITE,  // la memoria può essere letta e scritta
		MAP_ANON | MAP_PRIVATE,  // memoria non associata a un file e non condivisa
		-1, 0
	);
	if (p == MAP_FAILED) {
		perror("errore nella mmap");
		return EXIT_FAILURE;
	}

	strcpy(p, "Hello, World!");
	
	printf("--- Prima di mprotect ---\n");
	printf("Prima della modifica: %s\n", p);
	p[0] = 'X';
	printf("Dopo la modifica: %s\n", p);

	mprotect(p, pagesize, PROT_READ); // adesso la memoria puntata da p può essere solo letta
	
	printf("\n--- Dopo mprotect ---\n");
	printf("Prima della modifica: %s\n", p);
	p[0] = 'Y'; // <-- genera SIGSEGV
	printf("Dopo la modifica: %s\n", p);

    return EXIT_SUCCESS;
}
